1000 '=========================================================================
1010 AppName$ = "THE AVOID ( Graphics version )"
1020 AppVer$  = "Ver 1.11"
1030 Cright$  = "Copyright (C) 2002 by SHINTA"
1040 '=========================================================================
1050 '
1060 ' This sample game program is an one-key-action game.
1070 ' Your character is a white dot shown at left. Avoid circles and rectangles.
1080 ' Hit space key to turn.
1090 ' If near miss is occured, you get more scores ( "Kasuri" score in jargon ).
1100 ' Game clear at 1500 steps.
1110 '
1120 ' [ Used Commands ]
1130 ' CIRCLE, COLOR, LINE, PSET, ROLL etc.
1140 '
1150 ' [ Used Functions ]
1160 ' INKEY$, INPUT$, POINT, RND etc.
1170 '
1180 *PgmBegin '----- Program begin -------------------------------------------
1190 WIDTH 80,25:CONSOLE 0,25,0,1:COLOR:COLOR ,,,,2:COLOR=(1,&HFFF)
1200 HiScore=0:IF BE88VERSION$="" THEN ScrollDots=8 ELSE ScrollDots=2
1210 *GameLoop '----- Game loop -----------------------------------------------
1220 CLS 3 ' Clear screen
1230 Hit=0:Score=0:NearMiss=0:X=20:Y=200:DY=1 ' Init parameters
1240 *CreateStage '----- Create stage -----------------------------------------
1250 LOCATE 0,0:PRINT "Just a moment ..."
1260 FOR I=1 TO 500/ScrollDots
1270  GOSUB *Scroll:GOSUB *CreateObject
1280 NEXT
1290 NumSteps=0 ' Clear NumSteps
1300 *Ready '----- Ready to go ------------------------------------------------
1310 LOCATE 0,0:PRINT "Ready ...";SPC(20)
1320 GOSUB *ExpMyChr
1330 A=2000:GOSUB *Waiting
1340 *Main '----- Main routine ------------------------------------------------
1350 GOSUB *Scroll:IF NumSteps=1500 THEN GOTO *GameEnd
1360 GOSUB *CreateObject
1370 GOSUB *Move
1380 GOSUB *Score
1390 GOSUB *HitCheck:IF Hit=1 THEN GOTO *GameEnd
1400 GOSUB *ExpStatus
1410 GOSUB *ExpMyChr
1420 A=20:GOSUB *Waiting
1430 GOTO *Main
1440 *GameEnd ' ----- Game end ------------------------------------------------
1450 GOSUB *ExpStatus
1460 LINE(0,0)-(639,79),0,BF ' Clear top screen
1470 COLOR 7:LOCATE 0,1
1480 IF HIT=0 THEN PRINT "Game Clear" ELSE PRINT "Game Over"
1490 IF Score=HiScore THEN PRINT "Your score is hi score!!"
1500 A$="Retry":GOSUB *AskYN:IF YN$="Y" THEN GOTO *GameLoop
1510 END
1520 *AskYN '----- (SUB) Yes / No ---------------------------------------------
1530 '<in> A$:Message   <out> YN$:Answer ( "Y"=YES, "N"=NO )
1540 PRINT A$;" (Y/N)? ";
1550 *AskYNAsk
1560 YN$=INPUT$(1)
1570 IF YN$="Y" OR YN$="y" OR YN$="0" THEN YN$="Y":GOTO *AskYNExit         ' Yes : "Y", "y", "0"
1580 IF YN$="N" OR YN$="n" OR YN$=CHR$(&HD) THEN YN$="N":GOTO *AskYNExit   ' No  : "N", "n", Enter
1590 GOTO *AskYNAsk
1600 *AskYNExit
1610 PRINT YN$:RETURN
1620 *CreateObject '----- (SUB) Create object ---------------------------------
1630 IF INT(RND*5)>0 THEN RETURN ' Too many objects if create every time
1640 ObjColor1=INT(RND*5)+2:ObjColor2=INT(RND*14)+2 ' Select object's color at random
1650 ObjSizeX=INT(RND*20)+10:ObjSizeY=INT(RND*20)+10:ObjPosY=INT(RND*400) ' Select object's size at random
1660 ON INT(RND*2)+1 GOTO *COCircle,*CORect ' Select object's shape at random
1670 *COCircle ' Object is circle
1680 CIRCLE(639-ObjSizeX,ObjPosY),ObjSizeX,ObjColor1,,,ObjSizeY/ObjSizeX,F,ObjColor2
1690 RETURN
1700 *CORect ' Object is rectangle
1710 LINE(639-ObjSizeX,ObjPosY)-STEP(ObjSizeX,ObjSizeY),ObjColor1,BF,ObjColor2
1720 RETURN
1730 *ExpMyChr '----- (SUB) Show my character ---------------------------------
1740 PSET(X,Y),1
1750 RETURN
1760 *ExpStatus '----- (SUB) Show status --------------------------------------
1770 IF NearMiss=0 THEN COLOR 7 ELSE COLOR 4 ' If near miss is occuring, emphasize
1780 LOCATE 0,0:PRINT "STEPS:";NumSteps;"  SCORE:";Score;"  HI SCORE:";HiScore
1790 RETURN
1800 *HitCheck '----- (SUB) Check game over -----------------------------------
1810 IF POINT(X,Y)>=2 THEN Hit=1
1820 RETURN
1830 *Move '----- (SUB) Move my character -------------------------------------
1840 I$=INKEY$:IF I$=" " THEN DY=-DY ' Turn if space key is hit
1850 IF Y<20 THEN DY=1
1860 IF Y>380 THEN DY=-1
1870 Y=Y+DY
1880 RETURN
1890 *Score '----- (SUB) Calc score / "kasuri" score --------------------------
1900 NearMiss=0 ' Usually, "kasuri" score is 0
1910 IF POINT(X,Y-5)>=2 OR POINT(X,Y+5)>=2 OR POINT(X+ScrollDots*3,Y)>=2 THEN NearMiss=1
1920 IF POINT(X,Y-4)>=2 OR POINT(X,Y+4)>=2 OR POINT(X+ScrollDots*2,Y)>=2 THEN NearMiss=2
1930 IF POINT(X,Y-3)>=2 OR POINT(X,Y+3)>=2 OR POINT(X+ScrollDots*1,Y)>=2 THEN NearMiss=4
1940 IF POINT(X,Y-2)>=2 OR POINT(X,Y+2)>=2 THEN NearMiss=10
1950 IF POINT(X,Y-1)>=2 OR POINT(X,Y+1)>=2 THEN NearMiss=25
1960 Score=Score+1+NearMiss
1970 IF Score>HiScore THEN HiScore=Score
1980 RETURN
1990 *Scroll '----- (SUB) Scroll screen ---------------------------------------
2000 NumSteps=NumSteps+1
2010 ROLL ,ScrollDots
2020 RETURN
2030 *Waiting '----- (SUB) Wait -----------------------------------------------
2040 '<in> A:Time
2050 IF BE88VERSION$<>"" THEN GOTO *WaitingBe88
2060 FOR I=1 TO A*50:NEXT ' For real N88-BASIC on PC-9800 series
2070 RETURN
2080 *WaitingBe88
2090 SLEEP A ' SLEEP is the extensive command of Be88-BASIC
2100 RETURN


